Index: trunk/Delphes.cpp
===================================================================
--- trunk/Delphes.cpp	(revision 48)
+++ trunk/Delphes.cpp	(revision 49)
@@ -252,6 +252,14 @@
   case 4: {
     jet_def = fastjet::JetDefinition(fastjet::kt_algorithm, DET->CONERADIUS);
-    //jet_defs[4] = fastjet::JetDefinition(fastjet::cambridge_algorithm,jet_radius);
-    //jet_defs[5] = fastjet::JetDefinition(fastjet::antikt_algorithm,jet_radius);
+  }
+    break;
+    
+  case 5: {
+    jet_def = fastjet::JetDefinition(fastjet::cambridge_algorithm,DET->CONERADIUS);
+  }
+    break;
+    
+  case 6: {
+    jet_def = fastjet::JetDefinition(fastjet::antikt_algorithm,DET->CONERADIUS);
   }
     break;
@@ -375,6 +383,6 @@
 		TrackCentral.push_back(genMomentum);
 	      }
-	  
-} // switch
+	    
+	  } // switch
 	  
 	  // Forward particles in CASTOR ?
@@ -504,15 +512,15 @@
         // Tau jet identification : 1! track and electromagnetic collimation
         if(fabs(JET.Eta()) < (DET->MAX_TRACKER - DET->TAU_CONE_TRACKS)) {
-        double Energie_tau_central = DET->EnergySmallCone(towers,JET.Eta(),JET.Phi());
-        if(
-           ( Energie_tau_central/JET.E() > DET->TAU_EM_COLLIMATION ) &&
-           ( DET->NumTracks(TrackCentral,DET->PT_TRACK_TAU,JET.Eta(),JET.Phi()) == 1 ) &&
-           ( JET.Pt() > DET->TAUJET_pt)
-          ) {
-               elementTauJet = (TRootTauJet*) branchTauJet->NewEntry();
-               elementTauJet->Set(JET);
-            } // if tau jet
-           } // if JET.eta < tracker - tau_cone : Tau jet identification
-  
+	  double Energie_tau_central = DET->EnergySmallCone(towers,JET.Eta(),JET.Phi());
+	  if(
+	     ( Energie_tau_central/JET.E() > DET->TAU_EM_COLLIMATION ) &&
+	     ( DET->NumTracks(TrackCentral,DET->PT_TRACK_TAU,JET.Eta(),JET.Phi()) == 1 ) &&
+	     ( JET.Pt() > DET->TAUJET_pt)
+	     ) {
+	    elementTauJet = (TRootTauJet*) branchTauJet->NewEntry();
+	    elementTauJet->Set(JET);
+	  } // if tau jet
+	} // if JET.eta < tracker - tau_cone : Tau jet identification
+	
         if(JET.Pt() > DET->JET_pt)
           {
Index: trunk/src/SmearUtil.cc
===================================================================
--- trunk/src/SmearUtil.cc	(revision 48)
+++ trunk/src/SmearUtil.cc	(revision 49)
@@ -353,56 +353,79 @@
   f_out<<"#***************                                                     *"<<"\n";
   f_out<<"*                                                                    *"<<"\n";
+  f_out<<"*  Six algorithms are currently available:                           *"<<"\n";
+  f_out<<"*         - 1) CDF cone algorithm,                                   *"<<"\n";
+  f_out<<"*         - 2) CDF MidPoint algorithm,                               *"<<"\n";
+  f_out<<"*         - 3) SIScone algorithm,                                    *"<<"\n";
+  f_out<<"*         - 4) kt algorithm,                                         *"<<"\n";
+  f_out<<"*         - 5) Cambrigde/Aachen algorithm,                           *"<<"\n";
+  f_out<<"*         - 6) Anti-kt algorithm.                                    *"<<"\n";
+  f_out<<"*                                                                    *"<<"\n";
+  f_out<<"* You have chosen                                                    *"<<"\n";
   switch(JETALGO) {
   default:
   case 1: {
-    f_out<<"* CDF JetClu jet algorithm with:                                     *"<<"\n";
-    f_out << left << setw(40) <<"*        - Seed threshold:    "<<""
-	  << left << setw(10) <<SEEDTHRESHOLD                   <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Cone radius:       "<<""
-	  << left << setw(10) <<CONERADIUS                      <<""<< right << setw(20)<<"*"<<"\n";
-    f_out << left << setw(40) <<"*        - Adjacency cut:     "<<""
-	  << left << setw(10) <<C_ADJACENCYCUT                  <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Max iterations:    "<<""
-	  << left << setw(10) <<C_MAXITERATIONS                 <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Iratch:            "<<""
-	  << left << setw(10) <<C_IRATCH                        <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Overlap threshold: "<<""
-	  << left << setw(10) <<OVERLAPTHRESHOLD                <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
+  f_out<<"* CDF JetClu jet algorithm with parameters:                          *"<<"\n";
+  f_out << left << setw(40) <<"*        - Seed threshold:    "<<""
+        << left << setw(10) <<SEEDTHRESHOLD                   <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Cone radius:       "<<""
+        << left << setw(10) <<CONERADIUS                      <<""<< right << setw(20)<<"*"<<"\n";
+  f_out << left << setw(40) <<"*        - Adjacency cut:     "<<""
+        << left << setw(10) <<C_ADJACENCYCUT                  <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Max iterations:    "<<""
+        << left << setw(10) <<C_MAXITERATIONS                 <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Iratch:            "<<""
+        << left << setw(10) <<C_IRATCH                        <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Overlap threshold: "<<""
+        << left << setw(10) <<OVERLAPTHRESHOLD                <<""<< right << setw(20)<<"! not in datacard  *"<<"\n";
   }
     break;
   case 2: {
-    f_out<<"* CDF midpoint jet algorithm with:                                     *"<<"\n";
-    f_out << left << setw(40) <<"*        - Seed threshold:    "<<""
-	  << left << setw(20) <<SEEDTHRESHOLD                   <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Cone radius:       "<<""
-	  << left << setw(20) <<CONERADIUS                      <<""<< right << setw(10)<<"*"<<"\n";
-    f_out << left << setw(40) <<"*        - Cone area fraction:"<<""
-	  << left << setw(20) <<M_CONEAREAFRACTION              <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Maximum pair size: "<<""
-	  << left << setw(20) <<M_MAXPAIRSIZE                   <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Max iterations:    "<<""
-	  << left << setw(20) <<M_MAXITERATIONS                 <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Overlap threshold: "<<""
-	  << left << setw(20) <<OVERLAPTHRESHOLD                <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out<<"* CDF midpoint jet algorithm with parameters:                        *"<<"\n";
+  f_out << left << setw(40) <<"*        - Seed threshold:    "<<""
+        << left << setw(20) <<SEEDTHRESHOLD                   <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Cone radius:       "<<""
+        << left << setw(20) <<CONERADIUS                      <<""<< right << setw(10)<<"*"<<"\n";
+  f_out << left << setw(40) <<"*        - Cone area fraction:"<<""
+        << left << setw(20) <<M_CONEAREAFRACTION              <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Maximum pair size: "<<""
+        << left << setw(20) <<M_MAXPAIRSIZE                   <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Max iterations:    "<<""
+        << left << setw(20) <<M_MAXITERATIONS                 <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Overlap threshold: "<<""
+        << left << setw(20) <<OVERLAPTHRESHOLD                <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
   }
     break;
   case 3: {
-    f_out<<"* SISCone jet algorithm with:                                     *"<<"\n";
-    f_out << left << setw(40) <<"*        - Cone radius:             "<<""
-	  << left << setw(20) <<CONERADIUS                            <<""<< right << setw(10)<<"*"<<"\n";
-    f_out << left << setw(40) <<"*        - Overlap threshold:       "<<""
-	  << left << setw(20) <<OVERLAPTHRESHOLD                      <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Number pass max:         "<<""
-	  << left << setw(20) <<NPASS                                 <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
-    f_out << left << setw(40) <<"*        - Minimum pT for protojet: "<<""
-	  << left << setw(20) <<PROTOJET_PTMIN                        <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out <<"* SISCone jet algorithm with parameters:                            *"<<"\n";
+  f_out << left << setw(40) <<"*        - Cone radius:             "<<""
+        << left << setw(20) <<CONERADIUS                            <<""<< right << setw(10)<<"*"<<"\n";
+  f_out << left << setw(40) <<"*        - Overlap threshold:       "<<""
+        << left << setw(20) <<OVERLAPTHRESHOLD                      <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Number pass max:         "<<""
+	<< left << setw(20) <<NPASS                                 <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
+  f_out << left << setw(40) <<"*        - Minimum pT for protojet: "<<""
+	<< left << setw(20) <<PROTOJET_PTMIN                        <<""<< right << setw(10)<<"! not in datacard  *"<<"\n";
   }
     break;
   case 4: {
-    f_out<<"* KT jet algorithm with:                                          *"<<"\n";
-    f_out << left << setw(40) <<"*        - Cone radius: "<<""
-	  << left << setw(20) <<CONERADIUS                <<""<< right << setw(10)<<"*"<<"\n";
+  f_out <<"* KT jet algorithm with parameters:                                 *"<<"\n";
+  f_out << left << setw(40) <<"*        - Cone radius: "<<""
+        << left << setw(20) <<CONERADIUS                <<""<< right << setw(10)<<"*"<<"\n";
   }
     break;
+  case 5: {
+  f_out <<"* Cambridge/Aachen jet algorithm with parameters:                   *"<<"\n";
+  f_out << left << setw(40) <<"*        - Cone radius: "<<""
+        << left << setw(20) <<CONERADIUS                <<""<< right << setw(10)<<"*"<<"\n";
+  }
+    break;
+  case 6: {
+  f_out <<"* Anti-kt jet algorithm with parameters:                            *"<<"\n";
+  f_out << left << setw(40) <<"*        - Cone radius: "<<""
+        << left << setw(20) <<CONERADIUS                <<""<< right << setw(10)<<"*"<<"\n";
+  }
+    break;
+
+
   }
   f_out<<"*                                                                    *"<<"\n";