Index: /trunk/interface/BFieldProp.h
===================================================================
--- /trunk/interface/BFieldProp.h	(revision 54)
+++ /trunk/interface/BFieldProp.h	(revision 54)
@@ -0,0 +1,40 @@
+#ifndef _BFIELD_PROP_H_
+#define _BFIELD_PROP_H_
+
+/*
+ *   ---- Delphes ----
+ *     A Fast Simulator for general purpose LHC detector
+ *       S. Ovyn ~~~~ severine.ovyn@uclouvain.be
+ *
+ *         Center for Particle Physics and Phenomenology (CP3)
+ *           Universite Catholique de Louvain (UCL)
+ *             Louvain-la-Neuve, Belgium
+ *             */
+
+#include <vector>
+#include "TLorentzVector.h"
+
+#include "interface/SmearUtil.h"
+#include "Utilities/ExRootAnalysis/interface/BlockClasses.h"
+#include "Utilities/ExRootAnalysis/interface/TSimpleArray.h"
+
+using namespace std;
+
+class TrackPropagation : public RESOLution{
+
+ public:
+  // Constructor
+    TrackPropagation();
+ 
+    void Propagation(const TRootGenParticle *Part,TLorentzVector &genMomentum);
+
+    int TRACKING_RADIUS;
+    int TRACKING_LENGTH;
+    int MAXITERATION;
+    int MINSEGLENGTH;
+  
+};
+  
+#endif
+
+
Index: /trunk/interface/JetUtils.h
===================================================================
--- /trunk/interface/JetUtils.h	(revision 54)
+++ /trunk/interface/JetUtils.h	(revision 54)
@@ -0,0 +1,78 @@
+#ifndef _JETSUTIL_H_
+#define _JETSUTIL_H_
+
+/*
+  ---- Delphes ----
+  A Fast Simulator for general purpose LHC detector
+  S. Ovyn ~~~~ severine.ovyn@uclouvain.be
+  
+  Center for Particle Physics and Phenomenology (CP3)
+  Universite Catholique de Louvain (UCL)
+  Louvain-la-Neuve, Belgium
+*/
+
+/// \file SmearUtil.h
+/// \brief RESOLution class, and some generic definitions
+
+
+#include <vector>
+#include "TLorentzVector.h"
+
+#include "interface/SmearUtil.h"
+#include "Utilities/ExRootAnalysis/interface/BlockClasses.h"
+#include "Utilities/ExRootAnalysis/interface/TSimpleArray.h"
+#include "Utilities/ExRootAnalysis/interface/ExRootTreeReader.h"
+#include "Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h"
+#include "Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h"
+
+
+
+#include "Utilities/Fastjet/plugins/CDFCones/interface/PhysicsTower.hh"
+
+
+#include "TRandom.h"
+
+#include <iostream>
+#include <sstream>
+#include <fstream>
+#include <iomanip>
+#include <cstring>
+
+#include "Utilities/Fastjet/include/fastjet/PseudoJet.hh"
+#include "Utilities/Fastjet/include/fastjet/ClusterSequence.hh"
+
+// get info on how fastjet was configured
+#include "Utilities/Fastjet/include/fastjet/config.h"
+
+// make sure we have what is needed
+#ifdef ENABLE_PLUGIN_SISCONE
+#  include "Utilities/Fastjet/plugins/SISCone/SISConePlugin.hh"
+#endif
+#ifdef ENABLE_PLUGIN_CDFCONES
+#  include "Utilities/Fastjet/plugins/CDFCones/CDFMidPointPlugin.hh"
+#  include "Utilities/Fastjet/plugins/CDFCones/CDFJetCluPlugin.hh"
+#endif
+
+using namespace std;
+
+class JetsUtil: public RESOLution
+{
+ public:
+  /// Constructor
+  JetsUtil();
+
+
+  fastjet::JetDefinition jet_def;
+  fastjet::JetDefinition::Plugin * plugins;
+
+  vector<fastjet::PseudoJet> inclusive_jets;
+  vector<fastjet::PseudoJet> sorted_jets;
+  vector<fastjet::PseudoJet> RunJets(const vector<fastjet::PseudoJet> & input_particles);
+  
+  void RunJetBtagging(ExRootTreeWriter *treeWriter, ExRootTreeBranch *branchJet,const vector<fastjet::PseudoJet> & sorted_jets,const TSimpleArray<TRootGenParticle> & NFCentralQ);
+
+  void RunTauJets(ExRootTreeWriter *treeWriter, ExRootTreeBranch *branchTauJet,const vector<fastjet::PseudoJet> & sorted_jets,const vector<PhysicsTower> & towers, const vector<TLorentzVector> & TrackCentral);
+
+};
+
+#endif
Index: /trunk/interface/VeryForward.h
===================================================================
--- /trunk/interface/VeryForward.h	(revision 54)
+++ /trunk/interface/VeryForward.h	(revision 54)
@@ -0,0 +1,53 @@
+#ifndef _VERYFORWARD_H_
+#define _VERYFORWARD_H_
+
+/*
+  ---- Delphes ----
+  A Fast Simulator for general purpose LHC detector
+  S. Ovyn ~~~~ severine.ovyn@uclouvain.be
+  
+  Center for Particle Physics and Phenomenology (CP3)
+  Universite Catholique de Louvain (UCL)
+  Louvain-la-Neuve, Belgium
+*/
+
+/// \file SmearUtil.h
+/// \brief RESOLution class, and some generic definitions
+
+
+#include <vector>
+#include "TLorentzVector.h"
+
+#include "interface/SmearUtil.h"
+
+#include "Utilities/ExRootAnalysis/interface/BlockClasses.h"
+#include "Utilities/ExRootAnalysis/interface/TSimpleArray.h"
+#include "Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h"
+#include "Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h"
+
+#include "H_BeamParticle.h"
+#include "H_BeamLine.h"
+#include "H_RomanPot.h"
+
+
+#include "Utilities/Fastjet/plugins/CDFCones/interface/PhysicsTower.hh"
+
+using namespace std;
+
+class VeryForward : public RESOLution{
+
+ public:
+  /// Constructor
+  VeryForward();
+
+  void ZDC(ExRootTreeWriter *treeWriter,ExRootTreeBranch *branchZDC,TRootGenParticle *particle);
+  void RomanPots(ExRootTreeWriter *treeWriter, ExRootTreeBranch *branchRP220,ExRootTreeBranch *branchFP420,TRootGenParticle *particle) ;
+
+  bool relative_energy;
+  int kickers_on;
+
+ H_BeamLine* beamline1;
+ H_BeamLine* beamline2;
+
+};
+#endif