Index: cards/ILCgen/ILCgen_BTagging_N.tcl
===================================================================
--- cards/ILCgen/ILCgen_BTagging_N.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_BTagging_N.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -104,3 +104,2 @@
     source ILCgen/ILCgen_BTagging_50.tcl
 }
-
Index: cards/ILCgen/ILCgen_BeamCalEfficiency.tcl
===================================================================
--- cards/ILCgen/ILCgen_BeamCalEfficiency.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_BeamCalEfficiency.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -2,6 +2,4 @@
 # Based on IDR Figure 8.8a and Moritz Hebermehl PhD Thesis Figure 4.10
 # A.F.Zarnecki,  June 2020
-
-# set EfficiencyFormula {efficiency formula as a function of eta and pt}
 
 set EfficiencyFormula {
Index: cards/ILCgen/ILCgen_BeamCalF_Binning.tcl
===================================================================
--- cards/ILCgen/ILCgen_BeamCalF_Binning.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_BeamCalF_Binning.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -2,6 +2,6 @@
 # corrected by A.F.Zarnecki
 
-set pi [expr {acos(-1)}]
-    
+set pi [expr {acos(-1)} ]
+
 # BeamCal eta range 4.0 - 5.8 -> 2.099-0.347 =1.752deg
 #
Index: cards/ILCgen/ILCgen_BeamCalR_Binning.tcl
===================================================================
--- cards/ILCgen/ILCgen_BeamCalR_Binning.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_BeamCalR_Binning.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -2,6 +2,6 @@
 # corrected by A.F.Zarnecki
 
-set pi [expr {acos(-1)}]
-    
+set pi [expr {acos(-1)} ]
+
 # BeamCal eta range 4.0 - 5.8 -> 2.099-0.347 =1.752deg
 #
Index: cards/ILCgen/ILCgen_BeamCal_EnergyFractions.tcl
===================================================================
--- cards/ILCgen/ILCgen_BeamCal_EnergyFractions.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_BeamCal_EnergyFractions.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -1,4 +1,3 @@
 #P.Sopicki
-  # default energy fractions {abs(PDG code)} {fraction of energy deposited in BeamCal}
 
   add EnergyFraction {0} {0.0}
@@ -20,3 +19,2 @@
   add EnergyFraction {310} {0.3}
   add EnergyFraction {3122} {0.3}
-
Index: cards/ILCgen/ILCgen_BeamCal_Resolution.tcl
===================================================================
--- cards/ILCgen/ILCgen_BeamCal_Resolution.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_BeamCal_Resolution.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -1,6 +1,4 @@
 # P.Sopicki, corrected by A.F.Zarnecki
 # BeamCal resolution
-
-# set ResolutionFormula {resolution formula as a function of eta and energy}
 
   set ResolutionFormula {
@@ -8,3 +6,2 @@
   (abs(eta) > 4.8 && abs(eta) <= 5.8) * sqrt(energy^2*0.03^2 + energy*0.45^2) 
   }
-
Index: cards/ILCgen/ILCgen_CTagging_N.tcl
===================================================================
--- cards/ILCgen/ILCgen_CTagging_N.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_CTagging_N.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -104,3 +104,2 @@
     source ILCgen/ILCgen_CTagging_20.tcl
 }
-
Index: cards/ILCgen/ILCgen_ChrgHadMomentumSmearing.tcl
===================================================================
--- cards/ILCgen/ILCgen_ChrgHadMomentumSmearing.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_ChrgHadMomentumSmearing.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -6,17 +6,12 @@
 
 set ResolutionFormula {
-
-(abs(eta) <= 2.0) *
-  exp( -6.82012  - 0.284133*abs(eta) + 0.64585*eta*eta
+  (abs(eta) <= 2.0) *
+    exp( -6.82012  - 0.284133*abs(eta) + 0.64585*eta*eta
      + (0.829675 -0.188197*abs(eta) +  0.106226 * eta*eta  - 1.0) * log(pt)
      + (0.0766417-0.00435667*abs(eta) + 0.00174804*eta*eta) * log(pt)*log(pt))
-
-+
-
-(abs(eta) > 2.0 && abs(eta) <= 3.0) *
-  exp(  -4.54609
+  +
+  (abs(eta) > 2.0 && abs(eta) <= 3.0) *
+    exp(  -4.54609
      + ( 0.87526 - 1.0) * log(pt)
      + (-0.0800672 + 0.0891669 * abs(eta)) * log(pt)*log(pt))
-
-}
-
+  }
Index: cards/ILCgen/ILCgen_ChrgHadTrackingEff.tcl
===================================================================
--- cards/ILCgen/ILCgen_ChrgHadTrackingEff.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_ChrgHadTrackingEff.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -4,16 +4,18 @@
 #  A.F.Zarnecki, June 12, 2020
 
-  set EfficiencyFormula {                                                    (pt <= 0.1)   * (0.00)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.1 && pt <= 0.2)   * (0.70)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.2 && pt <= 0.3)   * (0.93)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.3 && pt <= 0.7)   * (0.995) +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.7)                * (1.00)  +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.1 && pt <= 0.2)   * (0.697) +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.2 && pt <= 0.3)   * (0.925) +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.3 && pt <= 0.7)   * (0.99)  +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.7)                * (0.995) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.1 && pt <= 0.2)   * (0.665) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.2 && pt <= 0.3)   * (0.884) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.3 && pt <= 0.7)   * (0.945) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.7)                * (0.95)  +
-                (abs(eta) > 3.00)                         *      (pt > 0.1)                * (0.00)  }
+set EfficiencyFormula {
+                                                                 (pt <= 0.1)   * (0.00)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.1 && pt <= 0.2)   * (0.70)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.2 && pt <= 0.3)   * (0.93)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.3 && pt <= 0.7)   * (0.995) +
+                       (abs(eta) <= 1.83)     *      (pt > 0.7)                * (1.00)  +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.1 && pt <= 0.2)   * (0.697) +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.2 && pt <= 0.3)   * (0.925) +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.3 && pt <= 0.7)   * (0.99)  +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.7)                * (0.995) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.1 && pt <= 0.2)   * (0.665) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.2 && pt <= 0.3)   * (0.884) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.3 && pt <= 0.7)   * (0.945) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.7)                * (0.95)  +
+    (abs(eta) > 3.00)                         *      (pt > 0.1)                * (0.00)
+  }
Index: cards/ILCgen/ILCgen_ECAL_EnergyFractions.tcl
===================================================================
--- cards/ILCgen/ILCgen_ECAL_EnergyFractions.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_ECAL_EnergyFractions.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -1,4 +1,4 @@
 #P.Sopicki
-# default energy fractions {abs(PDG code)} {fraction in ECAL or LumiCal}
+
   add EnergyFraction {0} {0.0}
   # energy fractions for e, gamma and pi0
Index: cards/ILCgen/ILCgen_ECAL_Resolution.tcl
===================================================================
--- cards/ILCgen/ILCgen_ECAL_Resolution.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_ECAL_Resolution.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -2,7 +2,7 @@
 # ECAL and LumiCal resolution: same formula used at the moment
 #
-# set ResolutionFormula {resolution formula as a function of eta and energy}
+
 set ResolutionFormula {
     (abs(eta) <= 3 )                 * sqrt(energy^2*0.01^2 + energy*0.17^2)+
     (abs(eta) > 3 && abs(eta) <= 4 ) * sqrt(energy^2*0.01^2 + energy*0.17^2) 
- }
+  }
Index: cards/ILCgen/ILCgen_ElectronEfficiency.tcl
===================================================================
--- cards/ILCgen/ILCgen_ElectronEfficiency.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_ElectronEfficiency.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -1,4 +1,2 @@
-
-  # set EfficiencyFormula {efficiency formula as a function of eta and pt}
 
 # efficiency formula for electrons (ECAL and LumiCal)
Index: cards/ILCgen/ILCgen_ElectronMomentumSmearing.tcl
===================================================================
--- cards/ILCgen/ILCgen_ElectronMomentumSmearing.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_ElectronMomentumSmearing.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -6,17 +6,12 @@
 
 set ResolutionFormula {
-
-(abs(eta) <= 2.0) *
-  exp( -6.82012  - 0.284133*abs(eta) + 0.64585*eta*eta
+  (abs(eta) <= 2.0) *
+    exp( -6.82012  - 0.284133*abs(eta) + 0.64585*eta*eta
      + (0.829675 -0.188197*abs(eta) +  0.106226 * eta*eta  - 1.0) * log(pt)
      + (0.0766417-0.00435667*abs(eta) + 0.00174804*eta*eta) * log(pt)*log(pt))
-
-+
-
-(abs(eta) > 2.0 && abs(eta) <= 3.0) *
-  exp(  -4.54609
+  +
+  (abs(eta) > 2.0 && abs(eta) <= 3.0) *
+    exp(  -4.54609
      + ( 0.87526 - 1.0) * log(pt)
      + (-0.0800672 + 0.0891669 * abs(eta)) * log(pt)*log(pt))
-
-}
-
+  }
Index: cards/ILCgen/ILCgen_ElectronTrackingEff.tcl
===================================================================
--- cards/ILCgen/ILCgen_ElectronTrackingEff.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_ElectronTrackingEff.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -4,16 +4,18 @@
 #  A.F.Zarnecki, June 12, 2020
 
-  set EfficiencyFormula {                                                    (pt <= 0.1)   * (0.00)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.1 && pt <= 0.2)   * (0.70)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.2 && pt <= 0.3)   * (0.93)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.3 && pt <= 0.7)   * (0.995) +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.7)                * (1.00)  +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.1 && pt <= 0.2)   * (0.697) +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.2 && pt <= 0.3)   * (0.925) +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.3 && pt <= 0.7)   * (0.99)  +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.7)                * (0.995) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.1 && pt <= 0.2)   * (0.665) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.2 && pt <= 0.3)   * (0.884) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.3 && pt <= 0.7)   * (0.945) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.7)                * (0.95)  +
-                (abs(eta) > 3.00)                         *      (pt > 0.1)                * (0.00)  }
+set EfficiencyFormula {
+                                                                 (pt <= 0.1)   * (0.00)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.1 && pt <= 0.2)   * (0.70)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.2 && pt <= 0.3)   * (0.93)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.3 && pt <= 0.7)   * (0.995) +
+                       (abs(eta) <= 1.83)     *      (pt > 0.7)                * (1.00)  +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.1 && pt <= 0.2)   * (0.697) +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.2 && pt <= 0.3)   * (0.925) +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.3 && pt <= 0.7)   * (0.99)  +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.7)                * (0.995) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.1 && pt <= 0.2)   * (0.665) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.2 && pt <= 0.3)   * (0.884) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.3 && pt <= 0.7)   * (0.945) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.7)                * (0.95)  +
+    (abs(eta) > 3.00)                         *      (pt > 0.1)                * (0.00)
+  }
Index: cards/ILCgen/ILCgen_HCAL_EnergyFractions.tcl
===================================================================
--- cards/ILCgen/ILCgen_HCAL_EnergyFractions.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_HCAL_EnergyFractions.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -1,4 +1,4 @@
 #P.Sopicki
-# default energy fractions {abs(PDG code)} {fraction in HCAL or LHCAL}
+
   add EnergyFraction {0} {1.0}
   # energy fractions for e, gamma and pi0
Index: cards/ILCgen/ILCgen_HCAL_Resolution.tcl
===================================================================
--- cards/ILCgen/ILCgen_HCAL_Resolution.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_HCAL_Resolution.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -2,8 +2,7 @@
 # HCAL and LHCAL resolution: same formula used at the moment
 #
-# set ResolutionFormula {resolution formula as a function of eta and energy}
+
 set ResolutionFormula {
    (abs(eta) <= 2.8 )                 * sqrt(energy^2*0.017^2 + energy*0.45^2)+
    (abs(eta) > 2.8 && abs(eta)<=3.8 ) * sqrt(energy^2*0.017^2 + energy*0.45^2)
-} 
-
+  }
Index: cards/ILCgen/ILCgen_MuonMomentumSmearing.tcl
===================================================================
--- cards/ILCgen/ILCgen_MuonMomentumSmearing.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_MuonMomentumSmearing.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -6,17 +6,12 @@
 
 set ResolutionFormula {
-
-(abs(eta) <= 2.0) *
-  exp( -6.82012  - 0.284133*abs(eta) + 0.64585*eta*eta
+  (abs(eta) <= 2.0) *
+    exp( -6.82012  - 0.284133*abs(eta) + 0.64585*eta*eta
      + (0.829675 -0.188197*abs(eta) +  0.106226 * eta*eta  - 1.0) * log(pt)
      + (0.0766417-0.00435667*abs(eta) + 0.00174804*eta*eta) * log(pt)*log(pt))
-
-+
-
-(abs(eta) > 2.0 && abs(eta) <= 3.0) *
-  exp(  -4.54609
+  +
+  (abs(eta) > 2.0 && abs(eta) <= 3.0) *
+    exp(  -4.54609
      + ( 0.87526 - 1.0) * log(pt)
      + (-0.0800672 + 0.0891669 * abs(eta)) * log(pt)*log(pt))
-
-}
-
+  }
Index: cards/ILCgen/ILCgen_MuonTrackingEff.tcl
===================================================================
--- cards/ILCgen/ILCgen_MuonTrackingEff.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_MuonTrackingEff.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -4,16 +4,18 @@
 #  A.F.Zarnecki, June 12, 2020
 
-  set EfficiencyFormula {                                                    (pt <= 0.1)   * (0.00)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.1 && pt <= 0.2)   * (0.70)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.2 && pt <= 0.3)   * (0.93)  +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.3 && pt <= 0.7)   * (0.995) +
-                                   (abs(eta) <= 1.83)     *      (pt > 0.7)                * (1.00)  +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.1 && pt <= 0.2)   * (0.697) +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.2 && pt <= 0.3)   * (0.925) +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.3 && pt <= 0.7)   * (0.99)  +
-                (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.7)                * (0.995) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.1 && pt <= 0.2)   * (0.665) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.2 && pt <= 0.3)   * (0.884) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.3 && pt <= 0.7)   * (0.945) +
-                (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.7)                * (0.95)  +
-                (abs(eta) > 3.00)                         *      (pt > 0.1)                * (0.00)  }
+set EfficiencyFormula {
+                                                                 (pt <= 0.1)   * (0.00)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.1 && pt <= 0.2)   * (0.70)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.2 && pt <= 0.3)   * (0.93)  +
+                       (abs(eta) <= 1.83)     *      (pt > 0.3 && pt <= 0.7)   * (0.995) +
+                       (abs(eta) <= 1.83)     *      (pt > 0.7)                * (1.00)  +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.1 && pt <= 0.2)   * (0.697) +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.2 && pt <= 0.3)   * (0.925) +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.3 && pt <= 0.7)   * (0.99)  +
+    (abs(eta) > 1.83 && abs(eta) <= 2.65)     *      (pt > 0.7)                * (0.995) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.1 && pt <= 0.2)   * (0.665) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.2 && pt <= 0.3)   * (0.884) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.3 && pt <= 0.7)   * (0.945) +
+    (abs(eta) > 2.65 && abs(eta) <= 3.00)     *      (pt > 0.7)                * (0.95)  +
+    (abs(eta) > 3.00)                         *      (pt > 0.1)                * (0.00)
+  }
Index: cards/ILCgen/ILCgen_PhotonEfficiency.tcl
===================================================================
--- cards/ILCgen/ILCgen_PhotonEfficiency.tcl	(revision d192152d4b8893651aaa798a2088188f14044724)
+++ cards/ILCgen/ILCgen_PhotonEfficiency.tcl	(revision 55f821af8fc61f15ba63e06f8d6e8cdb7581aabd)
@@ -1,6 +1,4 @@
-
-  # set EfficiencyFormula {efficiency formula as a function of eta and pt}
-
-  # efficiency formula for photons (ECAL + LumiCal)
+# set EfficiencyFormula (efficiency formula as a function of eta and pt)
+# efficiency formula for photons (ECAL + LumiCal)
 
   set EfficiencyFormula {